// *********************************************************************
//  Created with bc9Basic - BASIC To C/C++ Translator (V) 9.2.0.1 (2014/11/29)
//       The bc9Basic translator (bc9.exe) was compiled with
//                           g++ (tdm64-2) 4.8.1
// ----------------------------------------------------------------------
//                 BCX (c) 1999 - 2009 by Kevin Diggins
// *********************************************************************
//              Translated for compiling with a C Compiler
//                           On MS Windows
// *********************************************************************
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _UNICODE
#define _UNICODE
#endif
#define _X(y) y

//<---UNICODE AWARE
//>---UNICODE AWARE
// $HEADER BEGIN
#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#pragma comment(lib,"kernel32.lib")
#pragma comment(lib,"user32.lib")
#pragma comment(lib,"gdi32.lib")
// $HEADER END


// *************************************************
//        User's GLOBAL ENUM blocks
// *************************************************

// *************************************************
//            System Defined Constants
// *************************************************

typedef const char* ccptr;
#define CCPTR const char*
#define cfree free
#define WAITKEY system("pause")
#define EQU ==
#define cSizeOfDefaultString 2048

// *************************************************
//            User Defined Constants
// *************************************************

#define IDD_DLG1 1000
#define IDC_STC20 1001
#define IDC_INDEX 1002
#define IDC_STC21 1003
#define IDC_COMPANY 1004
#define IDC_STC22 1005
#define IDC_LASTNAME 1006
#define IDC_STC23 1007
#define IDC_FIRSTNAME 1008
#define IDC_STC24 1009
#define IDC_ADDRESS1 1010
#define IDC_ADDRESS2 1011
#define IDC_ADDRESS3 1012
#define IDC_STC25 1013
#define IDC_CITYNAME 1014
#define IDC_STC26 1015
#define IDC_STATENAME 1016
#define IDC_STC27 1017
#define IDC_ZIPCODE 1018
#define IDC_STC28 1019
#define IDC_COUNTRY 1020
#define IDC_STC29 1021
#define IDC_PHONE 1022
#define IDC_STC30 1023
#define IDC_FAX 1024
#define IDC_STC31 1025
#define IDC_EMAIL 1026
#define IDC_STC32 1027
#define IDC_URL 1028
#define IDC_STC33 - 1
#define IDC_COMMENTS 1029
#define IDC_PRIOR 1030
#define IDC_NEXT 1031
#define IDC_FIND 1032
#define IDC_ADD 1033
#define IDC_UPDATE 1034
#define IDC_DELETE 1035
#define IDC_PRINT 1036
#define IDR_MENU1 10000
#define IDM_FILE 10001
#define IDM_CLOSE 10002
#define IDM_HELP 10003
#define IDM_HELP2 10004
#define IDM_ABOUT 10005
#define IDD_DLG2 1100
#define IDC_STC1 1101
#define IDC_BTN1 1102
#define WM_APPLYFOCUS WM_USER+ 999
#define GBUF_SIZE 100
#define ADDRESSTYPE_CLASS struct _ADDRESSTYPE*
#define PROP_CLASS struct _PROP*

// *************************************************
//               Standard Prototypes
// *************************************************

double  MIN (double, double);
double  MAX (double, double);
// *************************************************
//          User Defined Types, Unions and Classes
// *************************************************


typedef struct _AddressType
{
    TCHAR    Company[64];
    TCHAR    LastName[32];
    TCHAR    FirstName[32];
    TCHAR    Address1[64];
    TCHAR    Address2[64];
    TCHAR    Address3[64];
    TCHAR    CityName[24];
    TCHAR    StateName[4];
    TCHAR    ZipCode[12];
    long     Country;
    TCHAR    Phone[24];
    TCHAR    Fax[24];
    TCHAR    Email[64];
    TCHAR    Url[64];
    TCHAR    Comments[1024];
} AddressType, *LPADDRESSTYPE;


typedef struct _Prop
{
    DWORD    usefont;
    HINSTANCE  hinstance;
    long     isrecmodified;
    long     isfilemodified;
    long     currententry;
    long     maxentries;
    TCHAR    findtext[MAX_PATH];
} Prop, *LPPROP;


// *************************************************
//            User Global Variables
// *************************************************

static Prop    gP;
static AddressType *gAddressBook;
static wchar_t gBuf[GBUF_SIZE];


// *************************************************
//               Standard Macros
// *************************************************


// *************************************************
//               User Prototypes
// *************************************************

void    AddCountries (HWND);
DWORD   FileSize (TCHAR*);
void    SetButtonStatus (HWND);
void    UdtToDialog (HWND, long);
void    DialogToUdt (HWND, long);
int     WINAPI WinMain (HINSTANCE, HINSTANCE, LPSTR, int);
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);
BOOL    CALLBACK AboutProc (HWND, UINT, WPARAM, LPARAM);

// *************************************************
//            User Global Initialized Arrays
// *************************************************


// *************************************************
//              User GLOBAL SET Statements
// *************************************************

const TCHAR* CountryNames[] =
{
    L"United States", L"Afghanistan", L"Albania", L"Algeria", L"Andorra", L"Angola", L"Anguilla",
    L"Antarctica", L"Argentina", L"Armenia", L"Aruba", L"Australia", L"Austria",
    L"Azerbaijan", L"Bahamas", L"Bahrain", L"Bangladesh", L"Barbados", L"Belarus",
    L"Belgium", L"Belize", L"Benin", L"Bermuda", L"Bhutan", L"Bolivia", L"Botswana",
    L"Bouvet Island", L"BosniaHerzogovina", L"Brazil", L"Brunei", L"Bulgaria",
    L"Burkina Faso", L"Cambodia", L"Cameroon", L"Canada", L"Cape Verde",
    L"Cayman Islands", L"Central African Rep", L"Chad", L"Chile", L"China",
    L"Christmas Island", L"Colombia", L"Comoros", L"Congo", L"Cook Islands",
    L"Costa Rica", L"Croatia", L"Cuba", L"Cyprus", L"Czech Republic", L"Denmark",
    L"Djibouti", L"Dominica", L"Dominican Republic", L"East Timor", L"Ecuador",
    L"Egypt", L"El Salvador", L"Equatorial Guinea", L"Eritrea", L"Estonia",
    L"Ethiopia", L"Falkland Islands", L"Faroe Islands", L"Fiji", L"Finland",
    L"France", L"France Metropolitan", L"French Guiana", L"French Polynesia",
    L"French S. Territories", L"Gabon", L"Gambia", L"Georgia", L"Germany", L"Ghana",
    L"Gibraltar", L"Greece", L"Greenland", L"Grenada", L"Guadeloupe", L"Guam",
    L"Guatemala", L"Guinea", L"Guinea-Bissau", L"Guyana", L"Haiti", L"Honduras",
    L"Hong Kong", L"Hungary", L"Iceland", L"IN India", L"Indonesia", L"Iran", L"Iraq",
    L"Ireland", L"Israel", L"Italy", L"Ivory Coast", L"Jamaica", L"Japan", L"Jordan",
    L"Kazakhstan", L"Kenya", L"Kiribati", L"Korea (North)", L"Korea (South)",
    L"Kuwait", L"Kyrgyzstan", L"Laos", L"Latvia", L"Lebanon", L"Lesotho", L"Liberia",
    L"Libya", L"Liechtenstein", L"Lithuania", L"Luxembourg", L"Macau", L"Macedonia",
    L"Madagascar", L"Malawi", L"Malaysia", L"Maldives", L"Mali", L"Malta",
    L"Marshall Islands", L"Martinique", L"Mauritania", L"Mauritius", L"Mayotte",
    L"Mexico", L"Micronesia", L"Miquelon", L"Moldova", L"Monaco", L"Mongolia", L"Montserrat",
    L"Morocco", L"Mozambique", L"Myanmar", L"Namibia", L"Nauru", L"Nepal",
    L"Netherlands", L"Nevis", L"New Caledonia", L"New Guinea", L"New Zealand",
    L"Nicaragua", L"Niger", L"Nigeria", L"Niue", L"Norfolk Island", L"Norway",
    L"Oman", L"Pakistan", L"Palau", L"Panama", L"Paraguay", L"Peru", L"Philippines",
    L"Pitcairn", L"Poland", L"Portugal", L"Principe", L"Puerto Rico", L"Qatar",
    L"Reunion", L"Romania", L"Russian Federation", L"Rwanda", L"Saint Kitts",
    L"Saint Lucia", L"Samoa", L"San Marino", L"Sao Tome", L"Saudi Arabia", L"Senegal",
    L"Seychelles", L"Sierra Leone", L"Singapore", L"Slovak Republic", L"Slovenia",
    L"Solomon Islands", L"Somalia", L"South Africa", L"Spain", L"Sri Lanka",
    L"St. Helena", L"St. Pierre", L"Sudan", L"Suriname", L"Swaziland", L"Sweden",
    L"Switzerland", L"Syria", L"Taiwan", L"Tajikistan", L"Tanzania", L"Thailand",
    L"Tobago", L"Togo", L"Tokelau", L"Tonga", L"Trinidad", L"Tunisia", L"Turkey",
    L"Turkmenistan", L"Tuvalu", L"Uganda", L"Ukraine", L"United Arab Emirates",
    L"United Kingdom", L"United States", L"Uruguay", L"Uzbekistan", L"Vanuatu",
    L"Vatican City State", L"Venezuela", L"Viet Nam", L"Virgin Islands (BR)",
    L"Virgin Islands (US)", L"Western Sahara", L"Yemen", L"Yugoslavia", L"Zaire",
    L"Zambia", L"Zimbabwe", L"Other", L""
};



// *************************************************
//                 Runtime Functions
// *************************************************

double MAX (double a, double b)
{
    if(a > b)
        return a;
    return b;
}


double MIN (double a, double b)
{
    if(a < b)
        return a;
    return b;
}



// *************************************************
//       User Subs, Functions and Class Methods
// *************************************************

void AddCountries (HWND hCmbo)
{
    int      i = {0};
    while(_tcslen(CountryNames[i]))
    {
        SendMessage(hCmbo, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)CountryNames[i]);
        i++;
    }

}


DWORD FileSize (TCHAR* szFileSpec)
{
    WIN32_FIND_DATA  fd = {0};
    DWORD    nRet = {0};
    HANDLE   hFind = {0};
    hFind = FindFirstFile( szFileSpec,  &fd);
    if(hFind != INVALID_HANDLE_VALUE )
    {
        FindClose(hFind);
        nRet = fd.nFileSizeLow;
    }
    return nRet;
}


void SetButtonStatus (HWND hWnd)
{
    if(gP.isrecmodified )
    {
        EnableWindow(GetDlgItem(hWnd, IDC_ADD), TRUE);
        EnableWindow(GetDlgItem(hWnd, IDC_UPDATE), TRUE);
    }
    else
    {
        EnableWindow(GetDlgItem(hWnd, IDC_ADD), FALSE);
        EnableWindow(GetDlgItem(hWnd, IDC_UPDATE), FALSE);
    }
    memset(gBuf, 0, GBUF_SIZE);
    //this works with TinyCC926 64    no buffer size here ????
#if defined __TINYC__
    swprintf(gBuf, L"%ld%ls%ld", gP.currententry, L" /", gP.maxentries);
#else
    //this needed for all other compilers VC++,PellesC,TDM-GCC,NUWEN
    swprintf(gBuf, GBUF_SIZE, L"%ld%ls%ld", gP.currententry, L" /", gP.maxentries);
#endif
    SetWindowText(GetDlgItem(hWnd, IDC_INDEX), gBuf);
    if(gP.maxentries )
    {
        EnableWindow(GetDlgItem(hWnd, IDC_FIND), TRUE);
        EnableWindow(GetDlgItem(hWnd, IDC_DELETE), TRUE);
        if(gP.currententry < 2 )
        {
            EnableWindow(GetDlgItem(hWnd, IDC_PRIOR), FALSE);
        }
        else
        {
            EnableWindow(GetDlgItem(hWnd, IDC_PRIOR), TRUE);
        }
        if(gP.currententry >= gP.maxentries )
        {
            EnableWindow(GetDlgItem(hWnd, IDC_NEXT), FALSE);
        }
        else
        {
            EnableWindow(GetDlgItem(hWnd, IDC_NEXT), TRUE);
        }
    }
    else
    {
        EnableWindow(GetDlgItem(hWnd, IDC_PRIOR), FALSE);
        EnableWindow(GetDlgItem(hWnd, IDC_NEXT), FALSE);
        EnableWindow(GetDlgItem(hWnd, IDC_FIND), FALSE);
        EnableWindow(GetDlgItem(hWnd, IDC_DELETE), FALSE);
    }
}


void UdtToDialog (HWND hWnd, long Index)
{
    struct _AddressType  Temp = {0};
    long     SaveState = {0};
    Temp = gAddressBook[Index];
    SaveState = gP.isrecmodified;
    gP.isrecmodified = TRUE;
    SetWindowText(GetDlgItem(hWnd, IDC_COMPANY), Temp.Company);
    SetWindowText(GetDlgItem(hWnd, IDC_LASTNAME), Temp.LastName);
    SetWindowText(GetDlgItem(hWnd, IDC_FIRSTNAME), Temp.FirstName);
    SetWindowText(GetDlgItem(hWnd, IDC_ADDRESS1), Temp.Address1);
    SetWindowText(GetDlgItem(hWnd, IDC_ADDRESS2), Temp.Address2);
    SetWindowText(GetDlgItem(hWnd, IDC_ADDRESS3), Temp.Address3);
    SetWindowText(GetDlgItem(hWnd, IDC_CITYNAME), Temp.CityName);
    SetWindowText(GetDlgItem(hWnd, IDC_STATENAME), Temp.StateName);
    SetWindowText(GetDlgItem(hWnd, IDC_ZIPCODE), Temp.ZipCode);
    SendMessage(GetDlgItem(hWnd, IDC_COUNTRY), (UINT)CB_SETCURSEL, (WPARAM)Temp.Country - 1, (LPARAM)0);
    SetWindowText(GetDlgItem(hWnd, IDC_PHONE), Temp.Phone);
    SetWindowText(GetDlgItem(hWnd, IDC_FAX), Temp.Fax);
    SetWindowText(GetDlgItem(hWnd, IDC_EMAIL), Temp.Email);
    SetWindowText(GetDlgItem(hWnd, IDC_URL), Temp.Url);
    SetWindowText(GetDlgItem(hWnd, IDC_COMMENTS), Temp.Comments);
    gP.isrecmodified = SaveState;
}


void DialogToUdt (HWND hWnd, long Index)
{
    struct _AddressType  Temp = {0};
    if(Index >= 0 && Index < 100 )
    {
        Temp = gAddressBook[Index];
        GetWindowText(GetDlgItem(hWnd, IDC_COMPANY), Temp.Company, sizeof(Temp.Company));
        GetWindowText(GetDlgItem(hWnd, IDC_LASTNAME), Temp.LastName, sizeof(Temp.LastName));
        GetWindowText(GetDlgItem(hWnd, IDC_FIRSTNAME), Temp.FirstName, sizeof(Temp.FirstName));
        GetWindowText(GetDlgItem(hWnd, IDC_ADDRESS1), Temp.Address1, sizeof(Temp.Address1));
        GetWindowText(GetDlgItem(hWnd, IDC_ADDRESS2), Temp.Address2, sizeof(Temp.Address2));
        GetWindowText(GetDlgItem(hWnd, IDC_ADDRESS3), Temp.Address3, sizeof(Temp.Address3));
        GetWindowText(GetDlgItem(hWnd, IDC_CITYNAME), Temp.CityName, sizeof(Temp.CityName));
        GetWindowText(GetDlgItem(hWnd, IDC_STATENAME), Temp.StateName, sizeof(Temp.StateName));
        GetWindowText(GetDlgItem(hWnd, IDC_ZIPCODE), Temp.ZipCode, sizeof(Temp.ZipCode));
        Temp.Country = SendMessage( GetDlgItem( hWnd, IDC_COUNTRY), ( UINT) CB_GETCURSEL, ( WPARAM) 0, ( LPARAM) 0) + 1;
        GetWindowText(GetDlgItem(hWnd, IDC_PHONE), Temp.Phone, sizeof(Temp.Phone));
        GetWindowText(GetDlgItem(hWnd, IDC_FAX), Temp.Fax, sizeof(Temp.Fax));
        GetWindowText(GetDlgItem(hWnd, IDC_EMAIL), Temp.Email, sizeof(Temp.Email));
        GetWindowText(GetDlgItem(hWnd, IDC_URL), Temp.Url, sizeof(Temp.Url));
        GetWindowText(GetDlgItem(hWnd, IDC_COMMENTS), Temp.Comments, sizeof(Temp.Comments));
        gAddressBook[Index] = Temp;
    }
}


int WINAPI WinMain (HINSTANCE hInst, HINSTANCE hPrev, LPSTR CmdLine, int CmdShow)
{
    WNDCLASSEX  wce = {0};
    HWND     hMainWin = {0};
    MSG      Msg = {0};
    TCHAR    szFileName[] = L"ADDRESSW.DAT";
    DWORD    BufferSize = {0};
    DWORD    ByttesReaded = {0};
    DWORD    BytesWritten = {0};
    HANDLE   hFile;
    struct _AddressType*  AddBookPtr;
    int      BookSize;
    TCHAR    ClassName[] = L"SDKADDRESS";
    wce.cbSize = sizeof( wce);
    wce.style = CS_HREDRAW | CS_VREDRAW;
    wce.cbWndExtra = DLGWINDOWEXTRA;
    wce.hInstance = hInst;
    wce.lpszClassName = ClassName;
    wce.lpfnWndProc = WndProc;
    wce.hIcon = LoadIcon( hInst, IDI_WINLOGO);
    wce.hCursor = LoadCursor( NULL, IDC_ARROW);
    wce.hbrBackground = ( HBRUSH)( COLOR_BTNFACE + 1);
    if(!RegisterClassEx( &wce))
    {
        MessageBox(0, L"Register Class PROBLEM", L"ERROR", MB_OK);
        return 0;
    }
    hMainWin = CreateDialogParam( hInst, MAKEINTRESOURCE( IDD_DLG1), 0, 0, 0);
    if(hMainWin == 0 )
    {
        MessageBox(0, L"Creation PROBLEM", L"ERROR", MB_OK);
        return 0;
    }
    BookSize = sizeof( AddressType);
    gP.hinstance = hInst;
    BufferSize = FileSize( szFileName);
    if(BufferSize )
    {
        gP.currententry = 1;
        gP.maxentries = BufferSize / sizeof( AddressType);
    }
    gAddressBook = malloc(( gP.maxentries + 1) * BookSize);
    AddBookPtr = gAddressBook;
    AddBookPtr++;
    hFile = CreateFile( szFileName, GENERIC_READ, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
    if(hFile != INVALID_HANDLE_VALUE )
    {
        ReadFile(hFile, AddBookPtr, BufferSize, &ByttesReaded, NULL);
        CloseHandle(hFile);
    }
    AddCountries(GetDlgItem(hMainWin, IDC_COUNTRY));
    UdtToDialog(hMainWin, gP.currententry);
    while(GetMessage( &Msg, NULL, 0, 0))
    {
        if((IsDialogMessage(hMainWin, &Msg) == 0))
        {
            TranslateMessage( &Msg);
            DispatchMessage( &Msg);
        }
    }

    cfree(gAddressBook);
    return Msg.wParam;
}


LRESULT CALLBACK WndProc (HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
    static HWND     hFocus;
    switch(Msg)
    {
    case WM_NCACTIVATE:
        if(wParam == 0 )
        {
            hFocus = GetFocus();
        }
        break;
    case WM_SETFOCUS:
        if(hFocus )
        {
            PostMessage(hWnd, WM_APPLYFOCUS, (WPARAM)hFocus, 0);
            hFocus = 0;
        }
        break;
    case WM_APPLYFOCUS:
        if(wParam )
        {
            SetFocus((HWND)wParam);
        }
        return 0;
        break;
    case WM_DESTROY:
        PostQuitMessage(0);
        return 0;
        break;
    case WM_COMMAND:
        if(HIWORD(wParam) == EN_UPDATE || ( LOWORD(wParam) == IDC_COUNTRY && HIWORD(wParam) == CBN_SELCHANGE))
        {
            if((gP.isrecmodified == 0))
            {
                gP.isrecmodified = TRUE;
                SetButtonStatus(hWnd);
            }
        }
        switch(LOWORD(wParam))
        {
        case IDM_ABOUT:
            DialogBox(gP.hinstance, MAKEINTRESOURCE(IDD_DLG2), hWnd, (DLGPROC)AboutProc);
            break;
        case IDCANCEL:
            PostMessage(hWnd, WM_CLOSE, 0, 0);
            return 0;
            break;
        case IDC_PRIOR:
            gP.currententry = MAX( gP.currententry - 1, 1);
            gP.isrecmodified = FALSE;
            UdtToDialog(hWnd, gP.currententry);
            SetButtonStatus(hWnd);
            return 0;
        case IDC_NEXT:
            gP.currententry = MIN( gP.currententry + 1, gP.maxentries);
            gP.isrecmodified = FALSE;
            UdtToDialog(hWnd, gP.currententry);
            SetButtonStatus(hWnd);
            return 0;
        }
    }
    return DefWindowProc(hWnd, Msg, wParam, lParam);
}


BOOL CALLBACK AboutProc (HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
    switch(Msg)
    {
    case WM_CLOSE:
        EndDialog(hWnd, 0);
        break;
    case WM_COMMAND:
        if(LOWORD(wParam) == IDC_BTN1 )
        {
            SendMessage(hWnd, (UINT)WM_CLOSE, (WPARAM)0, (LPARAM)0);
        }
        break;
    }
    return 0;
}



